#!/bin/bash

#Se ajusta las particiones en la tarjeta SD y se actualiza el SO

apt-get update;
apt-get upgrade;
apt-get install raspi-config;
raspi-config;

#Se instalan los paquetes que faltan en el script original 
echo "-------------------------------------------------------------------";
echo "Se instalan los paquetes que faltan en el script original";
echo "-------------------------------------------------------------------";
echo "";
echo "";
apt-get -y install sqlite;
apt-get -y install openssl shellinabox; #Instalar el Terminal Web
apt-get -y install python-kombu;
apt-get -y install python-mysqldb;
apt-get -y install python-simplejson;
apt-get -y install python-netifaces;
apt-get -y install python-pymongo;
apt-get -y install python-paramiko;
apt-get -y install gawk;
apt-get -y install postfix mailutils mpack;
apt-get -y install rsync;
apt-get -y install lsb-release;

#######################################################################################################
# Se instala Shinken, PNP4Nagios y NagVis a traves del script facilitado por sus desarrolladores.     #
# Junto con 1 plugin de Shinken, 1 paquete de modulos de Nagios y 4 modulos aparte de Nagios tambien. #
#######################################################################################################

echo "-------------------------------------------------------------------";
echo "Se instala Shinken, PNP4Nagios, NagVis y Nmap";
echo "Junto con:";
echo "1 plugin de Shinken";
echo "1 paquete de modulos de Nagios";
echo "4 modulos extra de Nagios";
echo "-------------------------------------------------------------------";
echo "";
echo "";

#Se conceden permisos al shell script de los desarrolladores
chmod -R 777 scriptshinken;

#Se instalan los paquetes necesarios mediante el script de Shinken

./scriptshinken -i ;						#Install Shinken Core
./scriptshinken -a pnp4nagios;					#Install pnp4nagios
./scriptshinken -a nagvis;					#Install nagvis
./scriptshinken -p nagios-plugins;				#Add nagios-plugins
./scriptshinken -p check_snmp_bandwidth;			#Add check_snmp_bandwidth (check bandwidth usage with snmp)
./scriptshinken -p manubulon;					#Add manubulon (snmp plugins)
./scriptshinken -p check_nwc_health;				#Add check_nwc_health
./scriptshinken -p check_netint;				#Add check_netint (enhanced version of check_snmp_int plugins)

#Se copian los archivos modificados en las carpetas correspondientes
echo "-------------------------------------------------------------------------------";
echo "Se copian los archivos modificados en las carpetas correspondientes";
echo "-------------------------------------------------------------------------------";
echo "";
echo "";

cp WuiViewEditMainCfg-MOD.php /usr/local/nagvis/share/server/core/classes/WuiViewEditMainCfg.php;
chown www-data:www-data /usr/local/nagvis/share/server/core/classes/WuiViewEditMainCfg.php;
rm /usr/local/shinken/WuiViewEditMainCfg-MOD.php;

cp header_element-MOD.tpl /usr/local/shinken/shinken/webui/views/header_element.tpl;
chown shinken:shinken /usr/local/shinken/shinken/webui/views/header_element.tpl;
rm /usr/local/shinken/header_element-MOD.tpl;

cp check_nwc_health-MOD /usr/local/shinken/libexec/check_nwc_health;
chown shinken:shinken /usr/local/shinken/libexec/check_nwc_health;
rm /usr/local/shinken/check_nwc_health-MOD;

cp commands-OS-Linux-MOD.cfg /usr/local/shinken/etc/packs/os/linux/commands.cfg;
chown shinken:shinken /usr/local/shinken/etc/packs/os/linux/commands.cfg;
rm /usr/local/shinken/commands-OS-Linux-MOD.cfg;

cp eltdetail-MOD.tpl /usr/local/shinken/shinken/webui/plugins/eltdetail/views/eltdetail.tpl;
chown shinken:shinken /usr/local/shinken/shinken/webui/plugins/eltdetail/views/eltdetail.tpl;
rm /usr/local/shinken/eltdetail-MOD.tpl;

cp nagvis.ini-MOD.php /usr/local/nagvis/etc/nagvis.ini.php;
chown www-data:www-data /usr/local/nagvis/etc/nagvis.ini.php;
rm /usr/local/shinken/nagvis.ini-MOD.php;

cp graph_content-MOD.php /usr/local/pnp4nagios/share/application/views/graph_content.php;
chown shinken:shinken /usr/local/pnp4nagios/share/application/views/graph_content.php;
rm /usr/local/shinken/graph_content-MOD.php;

cp default.header-MOD.html /usr/local/nagvis/share/userfiles/templates/default.header.html;
chown www-data:www-data /usr/local/nagvis/share/userfiles/templates/default.header.html;
rm /usr/local/shinken/default.header-MOD.html;

cp default.context-MOD.html /usr/local/nagvis/share/userfiles/templates/default.context.html;
chown www-data:www-data /usr/local/nagvis/share/userfiles/templates/default.context.html;
rm /usr/local/shinken/default.context-MOD.html;

cp NagVisShape-MOD.php /usr/local/nagvis/share/server/core/classes/objects/NagVisShape.php;
chown www-data:www-data /usr/local/nagvis/share/server/core/classes/objects/NagVisShape.php;
rm /usr/local/shinken/NagVisShape-MOD.php;

cp pnp4nagios-config-MOD.php /usr/local/pnp4nagios/etc/config.php;
chown shinken:shinken /usr/local/pnp4nagios/etc/config.php;
rm /usr/local/shinken/pnp4nagios-config-MOD.php;

cp pnp4Nagios-config_local-MOD.php /usr/local/pnp4nagios/etc/config_local.php;
chown shinken:shinken /usr/local/pnp4nagios/etc/config_local.php;
rm /usr/local/shinken/pnp4Nagios-config_local-MOD.php;

cp pnp4nagios-logo_box-MOD.php /usr/local/pnp4nagios/share/application/views/logo_box.php;
chown shinken:shinken /usr/local/pnp4nagios/share/application/views/logo_box.php; 
rm /usr/local/shinken/pnp4nagios-logo_box-MOD.php;


##########################################################################
# Solucion al problema de guardado de la configuracion general de NagVis #
##########################################################################
echo "-------------------------------------------------------------------------------";
echo "Se soluciona el error de guardado de la configuracion general de NagVis";
echo "-------------------------------------------------------------------------------";
echo "";
echo "";

#Esto resuelve un error de privilegios de escritura
chmod -R 777 /usr/local/nagvis/etc/nagvis.ini.php;

################################################################################
# Solucion a los problemas del buscador de equipos monitorizados en PNP4Nagios #
################################################################################
echo "-------------------------------------------------------------------------------";
echo "Se soluciona el error del buscador de equipos monitorizados en PNP4Nagios";
echo "-------------------------------------------------------------------------------";
echo "";
echo "";
#Se re-instala el servidor Apache
apt-get purge libapache2-mod-php5 php5; 
apt-get -y install libapache2-mod-php5 php5;
#Se activa el modulo de re-escritura de Apache
a2enmod rewrite;
#En /etc/apache2/sites-available/default se cambia "AllowOverride None" por "AllowOverride all"
sed -i 's/AllowOverride None/AllowOverride all/g' /etc/apache2/sites-available/default;

################################################################################
# Cambio de base de datos para los widgets de la seccion Dashboard	           #
################################################################################
echo "-------------------------------------------------------------------------------";
echo "Cambio de base de datos para los widgets de la seccion Dashboard";
echo "-------------------------------------------------------------------------------";
echo "";
echo "";
sed -i 's/  modules Apache_passwd, ActiveDir_UI, Cfg_password, PNP_UI, Mongodb, Glances_UI/  modules Apache_passwd, ActiveDir_UI, Cfg_password, PNP_UI, SQLitedb, Glances_UI/' /usr/local/shinken/etc/shinken-specific.cfg;


####################################################################################
# Una vez realizadas las correcciones se procede a la optimizacion del rendimiento #
####################################################################################

echo "--------------------------------------------------------------------------------";
echo "Una vez realizadas las correcciones se procede a la optimizacion del rendimiento";
echo "--------------------------------------------------------------------------------";
echo "";
echo "";
echo "mejora del swapping";
sed -i '$ a\vm.swappiness=0' /etc/sysctl.conf;

echo "mejora en el rendimiento del sistema deshabilitando la escritura cada vez que accede a la SD;
	esto tambien alarga la vida de la tarjeta de memoria";
sed -i 's/ext4    errors=remount-ro/ext4    relatime,errors=remount-ro/' /etc/fstab;

###########################################################################################################################
# Una vez realizadas las correcciones necesarias se copian los scripts de reconfiguración de IPs en el inicio del sistema #
###########################################################################################################################

echo "-----------------------------------------------------------------------------------------------------------------------";
echo "Una vez realizadas las correcciones necesarias se copian los scripts de reconfiguración de IPs en el inicio del sistema";
echo "-----------------------------------------------------------------------------------------------------------------------";
echo "";
echo "";

cp PNP4NagiosIP.sh /etc/init.d/PNP4NagiosIP.sh;
rm /usr/local/shinken/PNP4NagiosIP.sh;
chmod 777 /etc/init.d/PNP4NagiosIP.sh;
update-rc.d PNP4NagiosIP.sh defaults;

cp NagVisIPs.sh /etc/init.d/NagVisIPs.sh;
rm /usr/local/shinken/NagVisIPs.sh;
chmod 777 /etc/init.d/NagVisIPs.sh;
update-rc.d NagVisIPs.sh defaults;

cp raspIP.sh /etc/init.d/raspIP.sh;
rm /usr/local/shinken/raspIP.sh;
chmod 777 /etc/init.d/raspIP.sh;
update-rc.d raspIP.sh defaults;

reboot;


exit; 


### CUIDADO con los mapas exportados, ya que la direccion IP a la que apuntan los equipos/servicios en la
### configuracion de dichos mapas, es al servidor Shinken anterior y no al nuevo.

