#!/bin/bash
# -*- ENCODING: UTF-8 -*-

### BEGIN INIT INFO
# Provides:		La dirección IP de la Raspberry 
# Required-Start:	$syslog
# Required-Stop:	$syslog
# Default-Start:	2 3 4 5
# Default-Stop:		0 1 6
# Short-Description:	Envía la dirección IP de la raspberry mediante un email usando el comando mail
# Description:		(Anotación) CAMBIAR LA DIRECCION EMAIL DEL USUARIO EN LA LINEA DONDE SE EJECUTA EL ENVIO DEL EMAIL CON LOS DATOS (final de la línea 22)
#
### END INIT INFO

#Captura de los datos necesarios del sistema
ip=$(hostname -I | tr -d ' ');					#Dirección IP de la Raspberry
mac=$(/sbin/ifconfig|awk '/HWaddr/ {print substr($5, 0, 18)}');	#Dirección MAC de la Raspeberry
fecha=$(date +"%d-%m-%y");					#Fecha actual: Día-Mes-Año
hora=$(date +"%T");						#Hora actual: Hora:Minuto:segundo

#Envío del email con los datos. Cambiar EJEMPLO@PROVEEDOR.com donde por ejemplo podría ser bobesponja@gmail.com, ...@yahoo.com, ...@hotmail.com, o cualquier otro proveedor
echo "La dirección IP de la Raspberry Pi con la MAC $mac es: $ip" | mail -s "Dirección IP de la Raspberry Pi con la MAC $mac a fecha $fecha y hora $hora" EJEMPLO@PROVEEDOR.com;

exit;
